﻿Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Partial Class main_form
    Inherits System.Web.UI.Page

    Private _stateID As Integer

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '  The main form design sets the control states / properties, but
        '  call the load states dropdown method when the page loads . . .

        '  On first load of form AKA application launch, call
        '  the method to fill the states dropdown . . .

        If (Not (Page.IsPostBack)) Then
            Me.fillStatesDDLDS()
        End If

    End Sub

    Protected Sub statesDropDownList_TextChanged(sender As Object, e As System.EventArgs) Handles statesDropDownList.TextChanged

        '  Set the class stateID property based on the selected
        '  states dropdown value, set form control properties
        '  as appropriate, and call the load counties dropdown
        '  method . . .

        Me._stateID = Convert.ToInt32(Me.statesDropDownList.SelectedValue)
        Me.countiesDropDownList.Enabled = True
        Me.statesDropDownList.Enabled = False
        Me.btnBack.Enabled = True
        Me.loadCountiesDDL()
    End Sub

    Protected Sub countiesDropDownList_TextChanged(sender As Object, e As System.EventArgs) Handles countiesDropDownList.TextChanged

        '   Declare a child data access object . . .

        Dim listCitiesOfCountiesDT As New childDBObject

        '   Set up a list of SQL parameters for
        '   the relevant stored procedure . . .

        Dim prmList As New List(Of SqlParameter)

        '   The user might choose the first value in the counties
        '   dropdown - PICK A COUNTY - so simply ignore that
        '   pick . . .

        If (Me.countiesDropDownList.SelectedValue <> "") Then

            prmList.Add(New SqlParameter("@COUNTY_ID", Convert.ToInt32(Me.countiesDropDownList.SelectedValue)))

            '   Set the stored procedure for the data access object . . .

            listCitiesOfCountiesDT.SPName = "SELECT_CITIES_OF_COUNTY"

            '   Set the data access object dateTimeStamp and SPPrms properties . . .

            listCitiesOfCountiesDT.dateTimeStamp = DateTime.Now
            listCitiesOfCountiesDT.SPPrms = prmList

            '   The childDBObject.ExecuteSP method overrides
            '   method DBObject.ExecuteSP . . .

            Me.citiesOfCountyDG.DataSource = listCitiesOfCountiesDT.ExecuteSP()
            Me.citiesOfCountyDG.DataBind()

            Me.statesDropDownList.Enabled = False
            Me.countiesDropDownList.Enabled = False
            Me.btnBack.Enabled = False
            Me.citiesOfCountyDG.Visible = True
        End If

    End Sub

    Private Sub fillStatesDDLDS()

        '   Dim a new database access object, and set
        '   the stored procedure property. This SP
        '   doesn't need parameters, so don't worry
        '   about the SPParms property . . .

        Dim listCitiesDT As New parentDBObject
        listCitiesDT.SPName = "SELECT_ALL_STATES"

        With Me.statesDropDownList
            .DataTextField = "STATE_NAME"
            .DataValueField = "STATE_ID"

            '   Call the executeSP object method
            '   and use this as the combobox
            '   data source . . .

            .DataSource = listCitiesDT.executeSP()
            .DataBind()

            '   Artificially place a dummy dropdown list item so that the
            '   first result set pick in that list will work . . .

            .Items.Insert(0, New ListItem("PICK A STATE", ""))
        End With

    End Sub

    Private Sub loadCountiesDDL()

        '   Remove the dummy dropdown list item . . .

        Me.statesDropDownList.Items.Remove(New ListItem("PICK A STATE", ""))
        Dim listCountiesOfStateDT As New parentDBObject
        listCountiesOfStateDT.SPName = "SELECT_COUNTIES_OF_STATE"

        '   Set up a list of SQL parameters for
        '   relevant the stored procedure . . .

        Dim prmList As New List(Of SqlParameter)

        prmList.Add(New SqlParameter("@STATE_ID", _stateID))
        listCountiesOfStateDT.SPPrms = prmList

        '   Call the executeSP object method
        '   and use this as the combobox
        '   data source . . .

        Me.countiesDropDownList.DataSource = listCountiesOfStateDT.executeSP()
        Me.countiesDropDownList.DataTextField = "COUNTY NAME"
        Me.countiesDropDownList.DataValueField = "COUNTY_ID"
        Me.countiesDropDownList.DataBind()

        '   Artificially place a dummy dropdown list item so that the
        '   first result set pick in that list will work . . .

        Me.countiesDropDownList.Items.Insert(0, New ListItem("PICK A COUNTY", ""))

    End Sub

    Protected Sub btnBack_Click(sender As Object, e As System.EventArgs) Handles btnBack.Click

        '   Shift focus to the states combobox, "zero" out
        '   the counties combobox, and disable the back
        '   button because it did its job . . .

        Me.btnBack.Enabled = False
        Me.countiesDropDownList.Items.Clear()
        Me.countiesDropDownList.Enabled = False
        Me.statesDropDownList.Enabled = True
        Me.fillStatesDDLDS()

    End Sub

    Protected Sub citiesOfCountyDG_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles citiesOfCountyDG.RowDataBound

        '  Hide the state ID and city ID columns . . .

        If ((e.Row.RowType = DataControlRowType.DataRow) Or (e.Row.RowType = DataControlRowType.Header)) Then

            e.Row.Cells(1).Visible = False
            e.Row.Cells(4).Visible = False

        End If

    End Sub

    Protected Sub citiesOfCountyDG_RowCommand(sender As Object, e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles citiesOfCountyDG.RowCommand

        '  After the user clicks the datagrid command button to return
        '  to the counties dropdown, set focus to that dropdown, enable
        '  that dropdown, select PICK A COUNTY in that dropdown, hide
        '  the datagrid, and enable the back button . . .

        Me.countiesDropDownList.Focus()
        Me.countiesDropDownList.Enabled = True
        Me.countiesDropDownList.SelectedValue = ""
        Me.citiesOfCountyDG.Visible = False
        Me.btnBack.Enabled = True

    End Sub

End Class